package jp.tonosama.komoki.janscouterUtil;

public final class JanScouterUtil {

    public JanScouterUtil() {
    }

    public static native byte[] rotateYUV(byte[] img, int imgWidth, int imgHeight, int[] out );

    public static native void decodeYUV2BIN(byte[] img, int imgWidth, int imgHeight, int[] out );

    public static native void decodeYUV2GRAY(byte[] img, int imgWidth, int imgHeight, int[] out );

    public static native void decodeYUV2RGB(byte[] img, int imgWidth, int imgHeight, int[] out );

    public static native int JanDetector(
        byte[] img,         // J擾X[摜B
        int    imgWidth,    // byte[] img ̉TCYB
        int    imgHeight,   // byte[] img ̏cTCYB
        int    guidePosX,   // KChg̊Jnʒu X W
        int    guidePosY,   // KChg̊Jnʒu Y W
        int    guideWidth,  // KChg̉TCY
        int    guideHeight, // KChg̏cTCY
        int[]  pointX,      // evXWBo͗pB
        int[]  pointY,      // evYWBo͗pB
        int[]  tileWidth,   // ev̉Bo͗pB
        int[]  tileHeight,  // ev̏cBo͗pB
        byte[] hiArray,     // ev2l摜Bo͗pB
        int[]  edgeImg      // ͉摜BfobOpB
        );

    public static native int JanResultDetector(
        byte[]    img,         // J擾X[摜B
        int[]     imgSize,     // byte[] img ̉TCYAcTCYAKChg̊Jn X WAY WAKChg̉TCYAcTCYB͗pB
        int[]     pointX,      // evXWBo͗pB
        int[]     pointY,      // evYWBo͗pB
        int[]     tileWidth,   // ev̉Bo͗pB
        int[]     tileHeight,  // ev̏cBo͗pB
        byte[]    hiArray,     // ev2l摜Bo͗pB
        boolean[] nakiflag,    // vtOB
        int[]     haiNum,      // vAvAhv̐Bo͗pB
        byte[]    tehaiImg,    // v̉摜B  o͗pB
        byte[]    doraImg,     // hv̉摜Bo͗pB
        byte[]    nakiImg,     // v̉摜Bo͗pB
        int[]     edgeImg      // ͉摜BfobOpB
        );

    public static native int JanResultMatching(
        byte[]    sampleImg, // Tvp̔v摜B͗pB
        byte[]    tehai,     // ͂v̏Bo͗pB31432239EEE ݂ȊŒlĂāAꂼusŶPvƂu\[ŶTvƂӖĂB
        byte[]    dora,      // h̏Bo͗pB
        byte[]    nakihai,   // ͂v̏Bo͗pBuvƂusY345vƂ̒lB
        boolean[] nakiflag,  // vtOB
        int[]     haiNum,    // vAvAhv̐B͗pB
        byte[]    tehaiImg,  // v̉摜B  ͗pB
        byte[]    doraImg,   // hv̉摜B͗pB
        byte[]    nakiImg,   // v̉摜B͗pB
        int[]     edgeImg    // ͉摜BfobOpB
        );

    public static native int JanComputeResult(
        boolean[] condition,   // corA[`AꔭAVJCzEA`J ǂB
        byte[]    tehai,       // ͂v̏B31432239EEE ݂ȊŒlĂāAꂼusŶPvƂu\[ŶTvƂӖĂB
        byte[]    dora,        // h̏B
        byte[]    nakihai,     // ͂v̏BuvƂusY345vƂ̒lB
        boolean[] nakiflag,    // vǂ̏B
        int[]     result       // tAnA_̒lBі𖼁Bo͗pB
        );

    static
    {
        System.loadLibrary("JanScouterUtil");
    }
}
