#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <jni.h>
#include "common.h"

#define HORIZON 640
#define VERTICAL 390
#define COLORSNUMBER 3
#define FOURIER_LEN 128
#define COLOR_DEPTH 255
#define SOBEL 1
#define PREWITT 2
#define ORIGINAL 3
#define FROM_BOTTOM 1
#define FROM_TOP 2
#define FROM_LEFT 3
#define FROM_RIGHT 4
#define PI 3.14159265
#define NATIVE_DEBUG
#define FORK_THRESHOLD 30
#define FORK_DIVIDED_NUM_X 3
#define FORK_DIVIDED_NUM_Y 3
#define FORK_EDGE_DETECT_TH 32
#define CORRALATION_THRESHOLD 50
#define CONST_HAI_WIDTH 64
#define CONST_HAI_HEIGHT 96
#define LINEDETECTOR_WIDTH 15
#define LINEDETECTOR_ACCEPT 10
#define LINEDETECTOR_DEPTH 32


//ev𐔒l
enum HAITYPE {PINZU_1=0,PINZU_2,PINZU_3,PINZU_4,PINZU_5,PINZU_6,PINZU_7,PINZU_8,PINZU_9,
    WANZU_1,WANZU_2,WANZU_3,WANZU_4,WANZU_5,WANZU_6,WANZU_7,WANZU_8,WANZU_9,
    SOUZU_1,SOUZU_2,SOUZU_3,SOUZU_4,SOUZU_5,SOUZU_6,SOUZU_7,SOUZU_8,SOUZU_9,
    TONN,NANN,SHA,PEI,HAKU,HATSU,TYUNN,WANZU_AKA,PINZU_AKA,SOUZU_AKA,HAI_END
};

#define TOISU 3
#define SHUNTSU 1
#define MINKOU 2
#define ANKOU 4
#define MINKAN 8
#define ANNKAN 16  //v 32Av16

class FuStatus{
public:
	jbyte  hai; //v̏
	jbyte  status; // gCcAVcȂ
	bool is_agari; //v
	bool is_naki;  //v
};

class FuData{
public:
	FuStatus hidata[18];
	jint fu_result;
	jint yaku_result;
	jint score_result;
};

//v̊mASYQ
//tehaĩf[^ 3  2 3ԉɒׂB
int hai_sort(int pos, FuData *fudata){
	int i,j,k;

	for(i = pos ; fudata->hidata[i].hai != HAI_END  && i  < 14; i++){
		printf("hai = %d\n", fudata->hidata[i].hai);

		if(fudata->hidata[i].hai == fudata->hidata[i+1].hai && fudata->hidata[i].hai == fudata->hidata[i+2].hai){
			printf("ANKOU Ditect!! pos = %d\n", i);
			fudata->hidata[i].status   = ANKOU;
			fudata->hidata[i+1].status = ANKOU;
			fudata->hidata[i+2].status = ANKOU;

			i += 3;
			hai_sort(i, fudata);
			break;
		}
		else if(fudata->hidata[i].hai == fudata->hidata[i+1].hai){
			printf("TOITSU Ditect!! pos = %d\n", i);
			fudata->hidata[i].status   = TOISU;
			fudata->hidata[i+1].status = TOISU;

			i +=2;
			hai_sort(i, fudata);
			break;
		}
		else if((fudata->hidata[i].hai+1) == fudata->hidata[i+1].hai && (fudata->hidata[i].hai+2) == fudata->hidata[i+2].hai){
			if((fudata->hidata[i].hai >= PINZU_1 && fudata->hidata[i].hai <= PINZU_7)
			|| (fudata->hidata[i].hai >= WANZU_1 && fudata->hidata[i].hai <= WANZU_7)
			||(fudata->hidata[i].hai >= SOUZU_1 && fudata->hidata[i].hai <= SOUZU_7)){
				printf("SHUNTSU Ditect!! pos = %d\n", i);
				fudata->hidata[i].status   = SHUNTSU;
				fudata->hidata[i+1].status = SHUNTSU;
				fudata->hidata[i+2].status = SHUNTSU;
				i +=3;
				hai_sort(i, fudata);
				break;
			}
		}
	}
	printf("LoopEnd = %d\n");
	return 0;
}

int hai_nakisort(int pos, FuData *fudata){
//ToDo:ṽf[^ǉ
	int i;
	printf("hai_nakisort start  \n");
	for(i = pos ; fudata->hidata[i].hai != HAI_END  && i  < 14; i++){
		printf("hai = %d\n", fudata->hidata[i].hai);
		if(fudata->hidata[i].hai == fudata->hidata[i+1].hai
			&& fudata->hidata[i].hai == fudata->hidata[i+2].hai
			&& fudata->hidata[i].hai == fudata->hidata[i+3].hai
		){
			printf("MINKAN Ditect!! pos = %d\n", i);
			fudata->hidata[i].status   = MINKAN;
			fudata->hidata[i+1].status = MINKAN;
			fudata->hidata[i+2].status = MINKAN;
			fudata->hidata[i+3].status = MINKAN;
			i += 4;
			hai_nakisort(i, fudata);
			break;
		}
#if 0
		if(fudata->hidata[i].hai == fudata->hidata[i+1].hai
			&& fudata->hidata[i].hai == fudata->hidata[i+2].hai
			&& fudata->hidata[i].hai == fudata->hidata[i+3].hai
		){
			printf("ANKAN Ditect!! pos = %d\n", i);
			fudata->hidata[i].status   = ANNKAN;
			fudata->hidata[i+1].status = ANNKAN;
			fudata->hidata[i+2].status = ANNKAN;
			fudata->hidata[i+3].status = ANNKAN;
			i += 4;
			hai_nakisort(i, fudata);
			break;
		}
#endif
		else if(fudata->hidata[i].hai == fudata->hidata[i+1].hai && fudata->hidata[i].hai == fudata->hidata[i+2].hai){
			printf("MINKOU Ditect!! pos = %d\n", i);
			fudata->hidata[i].status   = MINKOU;
			fudata->hidata[i+1].status = MINKOU;
			fudata->hidata[i+2].status = MINKOU;

			i += 3;
			hai_nakisort(i, fudata);
			break;
		}
		else if((fudata->hidata[i].hai+1) == fudata->hidata[i+1].hai && (fudata->hidata[i].hai+2) == fudata->hidata[i+2].hai){
			if((fudata->hidata[i].hai >= PINZU_1 && fudata->hidata[i].hai <= PINZU_7)
			|| (fudata->hidata[i].hai >= WANZU_1 && fudata->hidata[i].hai <= WANZU_7)
			||(fudata->hidata[i].hai >= SOUZU_1 && fudata->hidata[i].hai <= SOUZU_7)){
				printf("SHUNTSU Ditect!! pos = %d\n", i);
				fudata->hidata[i].status   = SHUNTSU;
				fudata->hidata[i+1].status = SHUNTSU;
				fudata->hidata[i+2].status = SHUNTSU;
				i +=3;
				hai_nakisort(i, fudata);
				break;
			}
		}
	}
	printf("LoopEnd = %d\n");
	return 0;
}

int hai_check(){
//ToDo:  ^ꂽf[^̌`𐬂Ă邩mF
	return 0;
}

int hai_isyaochu(int val){
	switch(val){
		case WANZU_1:
		case WANZU_9:
		case PINZU_1:
		case PINZU_9:
		case SOUZU_1:
		case SOUZU_9:
			return 1;
			break;

		case HAKU:
		case HATSU:
		case TYUNN:
			return 2;
			break;

		case TONN:
		case NANN:
		case SHA:
		case PEI:
			return 3;
			break;
	}
	return 0;
}

int hai_fukeisan(FuData *fudata){
//ToDo:  ̌vZi[B
	int i;
	jint tokuten =0;

	for(i = 0; fudata->hidata[i].hai != HAI_END; i++){
		if(fudata->hidata[i].status == TOISU){
			if(hai_isyaochu( fudata->hidata[i].hai) == 2){
				tokuten += 2;
			}
			i +=1;
		}

		if(fudata->hidata[i].status == ANKOU){
			if(hai_isyaochu(  fudata->hidata[i].hai)){
				tokuten += 2 * fudata->hidata[i].status;
			}else {
				tokuten += 1 * fudata->hidata[i].status;
			}
			i +=2;
		}
	}

	//ToDo: ؂グ

	fudata->fu_result = tokuten + 20;
	return 0;
}


// Ԕv̖B オv̓ƃ\[g
int hai_presort(jbyte *tehai, FuData *fudata, bool is_nakihai){
	int i,j,k;
	jbyte tmp;
	jbyte agarihai;
	printf("hai_presort start \n");
	for(i = 0; tehai[i] != HAI_END; i++){
		fudata->hidata[i].hai  = tehai[i];
		if(tehai[i] ==  WANZU_AKA)
			fudata->hidata[i].hai =WANZU_5;
		if(tehai[i] ==  PINZU_AKA)
			fudata->hidata[i].hai  =PINZU_5;
		if(tehai[i] ==  SOUZU_AKA)
			fudata->hidata[i].hai  =SOUZU_5;
	}

	fudata->hidata[i].hai = tehai[i];
	if(is_nakihai) return 0;
	fudata->hidata[i-1].is_agari = true;

	printf("hai_presort start2 \n");
	printf("hai_presort  %02d \n", fudata->hidata[i].hai );
	for(i =1; tehai[i] != HAI_END; i++ ){
		tmp = fudata->hidata[i].hai ;
		printf("hai_presort  %02d \n", fudata->hidata[i].hai );
		if (fudata->hidata[i-1].hai > tmp){
			j = i;
			do {
				fudata->hidata[j].hai =fudata->hidata[j-1].hai;
				j--;
			} while(j>0 && fudata->hidata[j-1].hai > tmp);
			 fudata->hidata[j].hai = tmp;
		}
	}
	printf("hai_presort start3 \n");

	for(i =0; fudata->hidata[i].hai != HAI_END; i++ ){
		printf("hai_presort  %02d \n",  fudata->hidata[i].hai);
	}
}
int hai_yakukeisan(FuData *fudata){
//ToDo:vZďo
	fudata->yaku_result = 3;
}

int hai_tenkeisan(FuData *fudata){
//ToDo:_vZďo
	fudata->score_result = 5200;
}
int fukeisan_main(){
	int i,j,k;
	FuData fudata, fudata_tehai, fudata_naki;
	jbyte tehai[] = {   //p
	 PINZU_4, PINZU_4,
	 PINZU_5, PINZU_AKA , PINZU_5,
	 PEI, PEI, PINZU_4 ,HAI_END
	 };
	jbyte nakihai[] = {
	 WANZU_1, WANZU_2, WANZU_3,
	 HAKU, HAKU,  HAKU, HAI_END
	};

	jbyte tehai_fukeisan[18];

	hai_presort(tehai, &fudata_tehai, 0);

	hai_sort(0, &fudata_tehai);

	for(i = 0 ; i < 13; i++){
		printf("tehai i = %03d, haidata = %03d, haistate = %d\n",i, fudata_tehai.hidata[i].hai, fudata_tehai.hidata[i].status);
	}

	hai_presort(nakihai, &fudata_naki, 1);
	hai_nakisort(0, &fudata_naki);
	for(i = 0 ; i < 13; i++){
		printf("naki i = %03d, haidata = %03d, haistate = %d\n",i, fudata_naki.hidata[i].hai, fudata_naki.hidata[i].status);
	}

	hai_check();

	hai_fukeisan(&fudata);
	printf("fu_result = %d",fudata.fu_result);

	hai_yakukeisan(&fudata);
	printf("yaku_result = %d", fudata.yaku_result);

	hai_tenkeisan(&fudata);
	printf("score_result = %d", fudata.score_result);

	return 0;
}
