package jp.tonosama.komoki.objectInfo;

import android.graphics.PointF;
import android.util.Log;

public class FaceInfo {

    private final String TAG = "FaceInfo";
    private final boolean DebugFlg = false;

    private PointF mFacePoint;
    private float mEyeDistance;

    public FaceInfo() {
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
    }
    public void setFaceInfo(PointF face_point, float eye_distance) {
        mFacePoint   = face_point;
        mEyeDistance = eye_distance;
    }
    public PointF getFacePoint(){
        return mFacePoint;
    }
    public float getEyeDistance(){
        return mEyeDistance;
    }
}
